var $ = Object.defineProperty;
var h = (a, t, s) => t in a ? $(a, t, { enumerable: !0, configurable: !0, writable: !0, value: s }) : a[t] = s;
var i = (a, t, s) => h(a, typeof t != "symbol" ? t + "" : t, s);
import { reactive as o } from "vue-demi";
class n {
  constructor(t, s, r = {}) {
    i(this, "initialData");
    i(this, "formData");
    i(this, "rules");
    i(this, "options");
    i(this, "dirtyFields", /* @__PURE__ */ new Set());
    i(this, "formErrors", []);
    i(this, "$form");
    i(this, "$fields");
    this.initialData = o({ ...t }), this.formData = o(t), this.rules = s, this.options = r, this.$fields = {}, this.$form = {}, this.setupForm(), this.setupFields();
  }
  setupForm() {
    const t = this, s = Object.keys(this.formData);
    this.$form = {
      get $dirty() {
        return Object.values(t.$fields).some((r) => r.$dirty);
      },
      get $invalid() {
        return Object.values(t.$fields).some((r) => r.$invalid);
      },
      get $errors() {
        return t.formErrors;
      },
      $validate: () => s.map((r) => this.$fields[r].$validate()).every((r) => r),
      $reset: () => {
        s.forEach((r) => {
          this.$fields[r].$reset();
        });
      },
      $update: (r) => {
        Object.assign(this.formData, r), Object.assign(this.initialData, r);
      },
      $touch: () => {
        s.forEach((r) => {
          this.$fields[r].$touch();
        });
      }
    };
  }
  updateFormErrors() {
    this.formErrors.length = 0, Object.values(this.$fields).forEach((t) => {
      this.formErrors.push(...t.$errors);
    });
  }
  setupFields() {
    Object.keys(this.formData).forEach((t) => {
      this.$fields[t] = this.createFieldState(t);
    });
  }
  createFieldState(t) {
    const s = this, r = o({
      $invalid: !1,
      $dirty: !1,
      $errors: [],
      $touch: () => s.markAsDirty(t),
      $reset: () => {
        s.formData[t] = s.initialData[t], s.dirtyFields.delete(t), r.$dirty = !1, r.$errors = [], r.$invalid = !1;
      },
      $update: (e) => {
        s.formData[t] = e, s.options.lazy || s.validateField(t);
      },
      $validate: () => s.validateField(t),
      get value() {
        return s.formData[t];
      },
      set value(e) {
        s.formData[t] = e, s.options.lazy || s.validateField(t), s.options.autoTouch && s.markAsDirty(t);
      }
    });
    return r;
  }
  markAsDirty(t) {
    this.dirtyFields.has(t) || (this.dirtyFields.add(t), this.$fields[t].$dirty = !0);
  }
  validateField(t) {
    const s = this.formData[t], r = this.$fields[t];
    return r.$errors = [], this.rules[t].forEach((e) => {
      if (!e.test(s)) {
        const l = typeof e.message == "function" ? e.message(s) : e.message;
        r.$errors.push(`${e.name}: ${l}`);
      }
    }), r.$invalid = r.$errors.length > 0, this.updateFormErrors(), !r.$invalid;
  }
}
class f {
  buildForm(t, s, r) {
    return new n(t, s, r);
  }
}
export {
  f as FormManager
};
