import type { FormManagerInstance, FormOptions, ValidationRule } from './types';
export declare class FormManager {
    buildForm<T extends Record<string, unknown>>(data: T, rules: {
        [K in keyof T]: Array<ValidationRule<T[K]>>;
    }, options?: FormOptions): FormManagerInstance<T>;
}
